%%%%  P.S. Mukherjee October 2013


addpath(genpath('C:\research\new_denoising\paper\paper_submitted\codes'));
% Or, addpath(genpath(' .... the path of the foloder 'code ''));


% artificial image example
n1=64;n2=64;
img=zeros(n1,n2); nimg=zeros(n1,n2);
for i=1:n1; for j=1:n2; img(i,j)=(i==10)+(i==12)+(j==10)+(i+j==55)+0.5*(i/64);
        if (i>40 & j<25) img(i,j)=1.2+0*(i/128+0)+0*(j/128)^2;end;
end;end;
img(10,10)=1.08; img(12,10)=1.09; img(10,45)=1.08; img(12,43)=1.09;
img(58,32)=1.2;img(59,32)=1.2;img(60,32)=1.2; img(60,33)=1.2; img(60,34)=1.2;
img(1,54)=0.0; img(2,53)=0.0; img(3,52)=0.0;
for i=1:n1; for j=1:n2;
        if (i>20 & j>50)
        if (5*ceil(i/5)==i)
            img(i,j)=1.1;
        end;
        if (4*ceil(i/4)==i)
            img(i,j)=1.1;
        end;
        end
        if (i>20 & j>62) img(i,j)=1.1;end;
    end;end;



img_gr1=imfilter(img,fspecial('sobel'),'replicate');
img_gr2=imfilter(img,(fspecial('sobel'))','replicate');
img_gr=sqrt(img_gr1.^2+img_gr2.^2);

s=0;
for i=2:n1-1; for j=2:n2-1;
if (abs(img_gr1(i,j))>=abs(img_gr2(i,j))) s=s+abs(img(i+1,j)-img(i-1,j));end;
if (abs(img_gr1(i,j))<abs(img_gr2(i,j))) s=s+abs(img(i,j+1)-img(i,j-1));end;
end;end;
s=s/((n1-2)*(n2-2));


sigma = 0.1;
noisyimage = img+randn(size(img))*sigma; % Gaussian noise
denoised = CLdenoise(noisyimage,6.0,2.0,3.0);
mset = (denoised-img).^2; mse = mean(mset(:)); %MSE

ss=0;
for i=2:n1-1; for j=2:n2-1;
if (abs(img_gr1(i,j))>=abs(img_gr2(i,j))) ss=ss+abs(denoised(i+1,j)-denoised(i-1,j));end;
if (abs(img_gr1(i,j))<abs(img_gr2(i,j))) ss=ss+abs(denoised(i,j+1)-denoised(i,j-1));end;
end;end;
ss=ss/((n1-2)*(n2-2));
js=abs(s-ss)/s;  %EP
imagesc(denoised);colormap(gray);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cv = CLdenoise_cv(noisyimage,6.0,2.0,3.0); % CV-scores

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%  Thumbprint   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath(genpath('C:\research\new_denoising\paper\paper_submitted\codes'));
% Or, addpath(genpath(' .... the path of the foloder 'code ''));

fp1=imread('thumbprint.jpg');
fp1=rgb2gray(fp1);
[n1 n2]=size(fp1);
fp1=double(fp1);
img=fp1;

% Then, use similar codes as in the artificial image example.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 2-D brain %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath(genpath('C:\research\new_denoising\paper\paper_submitted\codes'));
% Or, addpath(genpath(' .... the path of the foloder 'code ''));

im1=imread('brain2.jpg');
im1=rgb2gray(im1);
[n1 n2]=size(im1);
im1=double(im1);
img=im1;

% Then, use similar codes as in the artificial image example.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%% 3-D brain  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% References are provided in the main article on how to get 3-D brain
% phantom. Then use the function 'CLdenoise3D'.
