function estimate = CLdenoise3D(noisyimage,nh,T,h)

%%%%  P.S. Mukherjee October 2013

nimg = noisyimage;
[n1 n2 n3] = size(nimg);
bd = 20;
pnimg = zeros(2*bd+n1,2*bd+n2,2*bd+n3);
nhh = 1.0; grid = 5; nh1=nh; nh2=1; nh_c=3*nh; h_c=10*h;

pnimg(1+bd:n1+bd,1+bd:n2+bd,1+bd:n3+bd)=nimg;


for i=bd+1:bd+n1; for j=bd+1:bd+n2; for k=1:bd; pnimg(i,j,k)=pnimg(i,j,2*bd-k+1);end;end;end;
for i=bd+1:bd+n1; for j=bd+1:bd+n2; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(i,j,2*(bd+n3)-k+1);end;end;end;
for i=bd+1:bd+n1; for j=1:bd; for k=bd+1:bd+n3; pnimg(i,j,k)=pnimg(i,2*bd-j+1,k);end;end;end;
for i=bd+1:bd+n1; for j=bd+n2+1:bd+n2+bd; for k=bd+1:bd+n3; pnimg(i,j,k)=pnimg(i,2*(bd+n2)-j+1,k);end;end;end;
for i=1:bd; for j=bd+1:bd+n2; for k=1+bd:bd+n3; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for i=bd+n1+1:bd+n1+bd; for j=bd+1:bd+n2; for k=1+bd:bd+n3; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for i=bd+1:bd+n1; for j=1:bd; for k=1:bd; pnimg(i,j,k)=pnimg(i,2*bd-j+1,k);end;end;end;
for i=bd+1:bd+n1; for j=1:bd; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(i,2*bd-j+1,k);end;end;end;
for i=bd+1:bd+n1; for j=bd+n2+1:bd+n2+bd; for k=1:bd; pnimg(i,j,k)=pnimg(i,2*(bd+n2)-j+1,k);end;end;end;
for i=bd+1:bd+n1; for j=bd+n2+1:bd+n2+bd; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(i,2*(bd+n2)-j+1,k);end;end;end;
for j=bd+1:bd+n2; for i=1:bd; for k=1:bd; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for j=bd+1:bd+n2; for i=1:bd; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for j=bd+1:bd+n2; for i=bd+n1+1:bd+n1+bd; for k=1:bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for j=bd+1:bd+n2; for i=bd+n1+1:bd+n1+bd; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for k=bd+1:bd+n3; for i=1:bd; for j=1:bd; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for k=bd+1:bd+n3; for i=1:bd; for j=bd+n2+1:bd+n2+bd; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for k=bd+1:bd+n3; for i=bd+n1+1:bd+n1+bd; for j=1:bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for k=bd+1:bd+n3; for i=bd+n1+1:bd+n1+bd; for j=bd+n2+1:bd+n2+bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for i=1:bd; for j=1:bd; for k=1:bd; pnimg(i,j,k)=pnimg(2*bd-i+1,j,k);end;end;end;
for i=bd+n1+1:bd+n1+bd; for j=1:bd; for k=1:bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for j=bd+n2+1:bd+n2+bd; for i=1:bd; for k=1:bd; pnimg(i,j,k)=pnimg(i,2*(bd+n2)-j+1,k);end;end;end;
for k=bd+n3+1:bd+n3+bd; for i=1:bd; for j=1:bd; pnimg(i,j,k)=pnimg(i,j,2*(bd+n3)-k+1);end;end;end;
for i=bd+n1+1:bd+n1+bd; for j=bd+n2+1:bd+n2+bd; for k=1:bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for k=bd+n3+1:bd+n3+bd; for i=bd+n1+1:bd+n1+bd; for j=1:bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;
for k=bd+n3+1:bd+n3+bd; for j=bd+n2+1:bd+n2+bd; for i=1:bd; pnimg(i,j,k)=pnimg(i,2*(bd+n2)-j+1,k);end;end;end;
for i=bd+n1+1:bd+n1+bd; for j=bd+n2+1:bd+n2+bd; for k=bd+n3+1:bd+n3+bd; pnimg(i,j,k)=pnimg(2*(bd+n1)-i+1,j,k);end;end;end;



est = zeros(2*bd+n1,2*bd+n2,2*bd+n3);
est_lck = zeros(2*bd+n1,2*bd+n2,2*bd+n3);

sumtemp1=0;
for i=bd+1:bd+n1;
    for j=bd+1:bd+n2;
        for k=bd+1:bd+n3
        c = 0;
        for i1=i-ceil(nhh):i+ceil(nhh);
            for j1=j-ceil(nhh):j+ceil(nhh);
                for k1=k-ceil(nhh):k+ceil(nhh);
                if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nhh^2)
                    c = c+1;
                    t(c) = pnimg(i1,j1,k1); tloc1(c) = i1; tloc2(c) = j1; tloc3(c) = k1;
                end;
                end;
            end;
        end;
        est_lck(i,j,k) = lck3([tloc1' tloc2' tloc3'],t',[i;j;k],nhh);
        sumtemp1 = sumtemp1 + (pnimg(i,j,k)-est_lck(i,j,k))^2;
    end;end;end;
sigmahat = sqrt(sumtemp1/(n1*n2*n3));
        
sigmahat;
        

for i=bd+1:bd+n1;
    for j=bd+1:bd+n2;
        for k=bd+1:bd+n3;
        c = 0;
        for i1=i-ceil(nh):i+ceil(nh);
            for j1=j-ceil(nh):j+ceil(nh);
                for k1=k-ceil(nh):k+ceil(nh);
                if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nh^2)
                    c = c+1;
                    t(c) = pnimg(i1,j1,k1); tloc1(c) = i1; tloc2(c) = j1; tloc3(c) = k1;
                end;
                end;
            end;
        end;
        
        var(t);
 
        if (var(t) < 1.0*sigmahat^2)
            
            ccc = 0;
            for i1=i-ceil(nh_c):i+ceil(nh_c);
            for j1=j-ceil(nh_c):j+ceil(nh_c);
            for k1=k-ceil(nh_c):k+ceil(nh_c);
                if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nh_c^2)
                    ccc = ccc+1;
                    ttt(ccc) = pnimg(i1,j1,k1);
                end;
            end;
            end;
            end;
            
            var(ttt);
            
            if (var(ttt) < 1.0*sigmahat^2)
            s = 0; wt = 0;
            tmat = pnimg(i-1:i+1,j-1:j+1,k-1:k+1);
            tempv1 = tmat(:);
            %tempv1 = [pnimg(i,j,k) pnimg(i-1,j,k) pnimg(i+1,j,k) pnimg(i,j-1,k) pnimg(i,j+1,k) pnimg(i,j,k-1) pnimg(i,j,k+1)];
            for i1=i-ceil(nh_c):i+ceil(nh_c);
                for j1=j-ceil(nh_c):j+ceil(nh_c);
                    for k1=k-ceil(nh_c):k+ceil(nh_c);
                    if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nh_c^2)
                        ttmat = pnimg(i1-1:i1+1,j1-1:j1+1,k1-1:k1+1);
                        tempv2 = ttmat(:);
                        %tempv2 = [pnimg(i1,j1,k1) pnimg(i1-1,j1,k1) pnimg(i1+1,j1,k1) pnimg(i1,j1-1,k1) pnimg(i1,j1+1,k1) ...
                        %          pnimg(i1,j1,k1-1) pnimg(i1,j1,k1+1) ];
                        w = exp(-((sum(tempv1 - tempv2).^2)/27)/(2*sigmahat^2*h_c));
                        wt = wt + w;
                        s = s + w*pnimg(i1,j1,k1);
                    end;
                    end;
                end;
            end;
            est(i,j,k) = s/wt;
            if (wt == 0)
                est(i,j,k) = pnimg(i,j,k);
            end;
            
            else
                
            s = 0; wt = 0;
            tmat = pnimg(i-1:i+1,j-1:j+1,k-1:k+1);
            tempv1 = tmat(:);
            %tempv1 = [pnimg(i,j,k) pnimg(i-1,j,k) pnimg(i+1,j,k) pnimg(i,j-1,k) pnimg(i,j+1,k) pnimg(i,j,k-1) pnimg(i,j,k+1)];
            for i1=i-ceil(nh1):i+ceil(nh1);
                for j1=j-ceil(nh1):j+ceil(nh1);
                    for k1=k-ceil(nh1):k+ceil(nh1);
                    if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nh1^2)
                        ttmat = pnimg(i1-1:i1+1,j1-1:j1+1,k1-1:k1+1);
                        tempv2 = ttmat(:);
                        %tempv2 = [pnimg(i1,j1,k1) pnimg(i1-1,j1,k1) pnimg(i1+1,j1,k1) pnimg(i1,j1-1,k1) pnimg(i1,j1+1,k1) ...
                        %          pnimg(i1,j1,k1-1) pnimg(i1,j1,k1+1)];
                        w = exp(-((sum(tempv1 - tempv2).^2)/27)/(2*sigmahat^2*h));
                        wt = wt + w;
                        s = s + w*pnimg(i1,j1,k1);
                    end;
                    end;
                end;
            end;
            est(i,j,k) = s/wt;
            if (wt == 0)
                est(i,j,k) = pnimg(i,j,k);
            end;
            
            end
    
        else
            mx = max(t); mn = min(t);       
            if (mx == mn)
                teststat = zeros(grid-1,1);
            else
                for tt=1:grid-1
                    tempsep = mn+(tt*(mx-mn))/grid;
                    gr1 = t((t<=tempsep)); gr2=setdiff(t,gr1);
                    ssw = (std(gr1,1))^2*(length(gr1)) + (std(gr2,1))^2*(length(gr2));
                    ssb = (std(t,1))^2*(c) - ssw;
                        if (ssw == 0)
                            teststat(tt) = 999999;
                        else
                            teststat(tt) = ssb/ssw;
                        end
                end
            end
            [m ind] = max(teststat);
            teststat;

            if (m < T)
                s = 0; wt = 0;
                tempv1 = [pnimg(i,j,k) pnimg(i-1,j,k) pnimg(i+1,j,k) pnimg(i,j-1,k) pnimg(i,j+1,k) pnimg(i,j,k-1) pnimg(i,j,k+1)];
                for i1=i-ceil(nh1):i+ceil(nh1);
                    for j1=j-ceil(nh1):j+ceil(nh1);
                        for k1=k-ceil(nh1):k+ceil(nh1);
                        if ((i1-i)^2+(j1-j)^2+(k1-k)^2 <= nh1^2)
                            tempv2 = [pnimg(i1,j1,k1) pnimg(i1-1,j1,k1) pnimg(i1+1,j1,k1) pnimg(i1,j1-1,k1) pnimg(i1,j1+1,k1) ...
                                  pnimg(i1,j1,k1-1) pnimg(i1,j1,k1+1)];
                            w = exp(-((sum(tempv1 - tempv2).^2)/7)/(2*sigmahat^2*h));
                            wt = wt + w;
                            s = s + w*pnimg(i1,j1,k1);
                        end
                        end
                    end
                end
                s;
                wt;
                est(i,j,k) = s/wt;
                if (wt == 0)
                    est(i,j,k) = pnimg(i,j,k);
                end
       
       
            else
                tempsep = mn+(ind*(mx-mn))/grid;
                cgr1 = find(t<=tempsep); cgr2 = setdiff(1:c,cgr1);
                gr1 = t(cgr1); gr2 = t(cgr2);
                locinfo = pnimg(i:i,j:j,k:k);
                locm = mean(locinfo(:));
       
                if (abs(locm-mean(gr1)) < abs(locm-mean(gr2)))
                    s = 0; wt = 0;
                    tempv1 = [pnimg(i,j,k) pnimg(i-1,j,k) pnimg(i+1,j,k) pnimg(i,j-1,k) pnimg(i,j+1,k) pnimg(i,j,k-1) pnimg(i,j,k+1)];
                    for i1=i-ceil(nh1):i+ceil(nh1);
                        for j1=j-ceil(nh1):j+ceil(nh1);
                            for k1=k-ceil(nh1):k+ceil(nh1);
                            % already considering circular
                            if (ismember(pnimg(i1,j1,k1),gr1)==1)
                                tempv2 = [pnimg(i1,j1,k1) pnimg(i1-1,j1,k1) pnimg(i1+1,j1,k1) pnimg(i1,j1-1,k1) pnimg(i1,j1+1,k1) ...
                                  pnimg(i1,j1,k1-1) pnimg(i1,j1,k1+1)];
                                w = exp(-((sum(tempv1 - tempv2).^2)/7)/(2*sigmahat^2*h));
                                wt = wt + w;
                                s = s + w*pnimg(i1,j1,k1);
                            end
                            end
                        end
                    end
                    s;
                    wt;
                    est(i,j,k) = s/wt;
                    if (wt == 0)
                        %est(i,j,k)=-5;
                        est(i,j,k) = pnimg(i,j,k);
                    end;
                else
                    s = 0; wt = 0;
                    tempv1 = [pnimg(i,j,k) pnimg(i-1,j,k) pnimg(i+1,j,k) pnimg(i,j-1,k) pnimg(i,j+1,k) pnimg(i,j,k-1) pnimg(i,j,k+1)];
                        for i1=i-ceil(nh1):i+ceil(nh1)
                            for j1=j-ceil(nh1):j+ceil(nh1);
                                for k1=k-ceil(nh1):k+ceil(nh1);
                                % already considering circular
                                if (ismember(pnimg(i1,j1,k1),gr2)==1)
                                    tempv2 = [pnimg(i1,j1,k1) pnimg(i1-1,j1,k1) pnimg(i1+1,j1,k1) pnimg(i1,j1-1,k1) pnimg(i1,j1+1,k1) ...
                                  pnimg(i1,j1,k1-1) pnimg(i1,j1,k1+1)];
                                    w = exp(-((sum(tempv1 - tempv2).^2)/7)/(2*sigmahat^2*h));
                                    w;
                                    wt = wt + w;
                                    s = s + w*pnimg(i1,j1,k1);
                                end
                                end
                            end
                        end
                        pnimg(i,j,k);
                        gr2;
                        s;
                        wt;
                        1000000;
                    est(i,j,k) = s/wt;
                    if (wt == 0)
                        %est(i,j,k)=-5;
                        est(i,j,k)= pnimg(i,j,k);
                    end
                end
            end
            clear t gr1 gr2 teststat tloc1 tloc2 tloc3 cgr1 cgr2 ttt;
        end
        end
    end
end

estimate = est(bd+1:bd+n1,bd+1:bd+n2,bd+1:bd+n3);
